//--------------------------------------
//
// DirectInput.h 
// Inits Dinput and gives callback access to Keyboard and Mouse
// Jason Kim August 2009
//
//--------------------------------------

//#Defines
#ifndef DIRECT_INPUT_H
#define DIRECT_INPUT_H

#define DIRECTINPUT_VERSION 0x0800

//includes
#include <dinput.h>
#include <windows.h>
#include <winuser.h>

//Class for DirectInput Use
class DirectInput
{
public:
	//Constructor
	DirectInput(DWORD keyboardCoopFlags, DWORD mouseCoopFlags);
	
	//Destructor
	~DirectInput();

	//Function to Poll Mouse and Keyboard Devices
	void poll();
	
	//bool is Key Down
	bool keyDown(char key);

	//bool for is Mouse Button Down
	bool mouseButtonDown(int button);

	//Mouse Variables
	float mouseDX();
	float mouseDY();
	float mouseDZ();

	float mousePosX();
	float mousePosY();


private:
	// Make private to prevent copying of members of this class.
	DirectInput(const DirectInput& rhs);
	DirectInput& operator=(const DirectInput& rhs);
		
private:
	IDirectInput8*       mDInput;

	IDirectInputDevice8* mKeyboard;
	char                 mKeyboardState[256]; 

	IDirectInputDevice8* mMouse;
	DIMOUSESTATE2        mMouseState;

	//Windows Mouse
	POINT				 mMousePoint;
};
extern DirectInput* gDInput;

#endif // DIRECT_INPUT_H