//Jason Kim
//I have chosen to include FMOD as the sound system for this simple 2D shooter game, to show I can implement 3rd Party Software into modules.
//FMOD is a free Sound System API for the PC available at www.fmod.org
//Also made it a Singleton so only one Sound Class Instance is in the entire Scope of Project.

#include "fmod.hpp" //Fmod EX Sound System

class Sound 
{
private:
	//Singleton Implementation
	Sound(){}; //private constructor
	Sound(Sound const&){}; //private copy Constructor
	Sound& operator=(Sound const&){}; //private assignment operator
	static Sound* m_pInstance;// static instance pointer to single instance of class.

	//private class vars
    static bool SoundOK; //Sound System OK?
    static char * currentSound; //currently played sound

    //FMOD API
    static FMOD_RESULT result;
    static FMOD_SYSTEM * fmodsystem;
    static FMOD_SOUND * sound1;// background music
	static FMOD_SOUND * sound2;// sound effect
    static FMOD_CHANNEL * channel;

public:
	//Singleton Implementation
	static Sound* Instance(); // Function to get the single instance of class

	//Destructor
	~Sound();

	//Sound Controls
    static void init (void); //inits FMOD sound system
	static void load (const char * filename, int SoundID); //loads a sound (mp3/wav/etc.)
	static void unload (int SoundID); //unload/frees the sound object
	static void play (bool pause = false, int SoundID = 0); //plays a sound

};